#include <torch/csrc/autograd/python_enum_tag.h>
#include <torch/csrc/utils/pybind.h>
#include <pybind11/pybind11.h>
#include <ATen/core/enum_tag.h>

namespace py = pybind11;
namespace torch {
    namespace autograd {
    void initEnumTag(PyObject* module) {
        auto m = py::handle(module).cast<py::module>();
        py::enum_<at::Tag>(m, "Tag")
        
        .value("inplace_view", at::Tag::inplace_view)
        .value("nondeterministic_bitwise", at::Tag::nondeterministic_bitwise)
        .value("dynamic_output_shape", at::Tag::dynamic_output_shape)
        .value("core", at::Tag::core)
        .value("nondeterministic_seeded", at::Tag::nondeterministic_seeded)
        .value("data_dependent_output", at::Tag::data_dependent_output)
        .value("view_copy", at::Tag::view_copy)
        .value("generated", at::Tag::generated)
        .value("pointwise", at::Tag::pointwise);
        m.doc() = "An Enum that contains tags that can be assigned to an operator registered in C++.";
    }
}}
